---
title: WEBGL_lose_context
slug: Web/API/WEBGL_lose_context
tags:
  - API
  - Reference
  - WebGL
  - WebGL extension
---
<div>{{APIRef("WebGL")}}</div>

<p>The <strong>WEBGL_lose_context</strong> extension is part of the <a href="/en-US/docs/Web/API/WebGL_API">WebGL API</a> and exposes functions to simulate losing and restoring a {{domxref("WebGLRenderingContext")}}.</p>

<p>WebGL extensions are available using the {{domxref("WebGLRenderingContext.getExtension()")}} method. For more information, see also <a href="/en-US/docs/Web/API/WebGL_API/Using_Extensions">Using Extensions</a> in the <a href="/en-US/docs/Web/API/WebGL_API/Tutorial">WebGL tutorial</a>.</p>

<div class="note">
<p><strong>Availability:</strong> This extension is available to both, {{domxref("WebGLRenderingContext", "WebGL1", "", 1)}} and {{domxref("WebGL2RenderingContext", "WebGL2", "", 1)}} contexts.</p>
</div>

<h2 id="Methods">Methods</h2>

<dl>
 <dt>{{domxref("WEBGL_lose_context.loseContext()")}}</dt>
 <dd>Simulates losing the context.</dd>
 <dt>{{domxref("WEBGL_lose_context.restoreContext()")}}</dt>
 <dd>Simulates restoring the context.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<p>With this extension, you can simulate the <code><a href="/en-US/docs/Web/API/HTMLCanvasElement/webglcontextlost_event">webglcontextlost</a></code> and <code><a href="/en-US/docs/Web/API/HTMLCanvasElement/webglcontextrestored_event">webglcontextrestored</a></code> events:</p>

<pre class="brush: js">const canvas = document.getElementById('canvas');
const gl = canvas.getContext('webgl');

canvas.addEventListener('webglcontextlost', (event) =&gt; {
  console.log(event);
});

gl.getExtension('WEBGL_lose_context').loseContext();

// WebGLContextEvent event with type "webglcontextlost" is logged.
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('WEBGL_lose_context', "", "WEBGL_lose_context")}}</td>
   <td>{{Spec2('WEBGL_lose_context')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p class="hidden">The compatibility table in this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>

<p>{{Compat("api.WEBGL_lose_context.loseContext")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("WebGLRenderingContext.isContextLost()")}}</li>
 <li>Events: <code><a href="/en-US/docs/Web/API/HTMLCanvasElement/webglcontextlost_event">webglcontextlost</a></code>, <code><a href="/en-US/docs/Web/API/HTMLCanvasElement/webglcontextrestored_event">webglcontextrestored</a></code>, <code><a href="/en-US/docs/Web/API/HTMLCanvasElement/webglcontextcreationerror_event">webglcontextcreationerror</a></code></li>
</ul>
